/*-- Oak Tree --*/

#include Library_Plant

// Abusing the Seed() call for checking season
public func Seed()
{
	// Autumn
	if(Inside(GetSeason(), 75, 98) && !GetMeshMaterial() == "Tree_Oak_Autumn" && !Random(3))
		SetMeshMaterial("Tree_Oak_Autumn");
	// Winter
	if(Inside(GetSeason(), 99, 24) && !GetMeshMaterial() == "Tree_Oak_Autumn" && !Random(3))
		SetMeshMaterial("Tree_Oak_Autumn");
	// Spring + Summer
	if(Inside(GetSeason(), 25, 74) && !GetMeshMaterial() == "Tree_Oak" && !Random(3))
		SetMeshMaterial("Tree_Oak");
	
	return _inherited();	
}

// Overloaded from the plant library to add the foreground parameter, foreground = true will roughly make every 3rd tree foreground (not the offspring though)
func Place(int amount, proplist rectangle, proplist settings, bool foreground)
{
	// Default behaviour
	var trees = inherited(amount, rectangle, settings);
	if (GetLength(trees) < 1) return trees;

	for (var tree in trees)
		if (!Random(3))
			tree.Plane = 510;
	return trees;
}

private func SeedChance() {	return 500; }
private func SeedArea() { return 400; }
private func SeedAmount() { return 12; }

func Construction()
{
	StartGrowth(5);
	// set random rotation and scale so trees don't look alike too much
	var size = RandomX(700, 1050);
	SetProperty("MeshTransformation", Trans_Mul(Trans_Rotate(Random(360),0,1,0), Trans_Scale(size, size, size)));
	if (!Random(3))
		this.Plane = 510;
	inherited(...);
}

public func IsTree() { return true; }

public func ChopDown()
{
	// Use Special Vertex Mode 1 (see documentation) so the removed vertex won't come back when rotating the tree.
	SetVertex(0, VTX_Y, 0, 1);
	// Remove the bottom vertex
	RemoveVertex(0);

	_inherited(...);
}

func Damage()
{
	_inherited();

	if (GetDamage() > MaxDamage() && OnFire())
	{
		var burned = CreateObject(Tree_Oak_Burned, 0, 0, GetOwner());
		burned->SetCategory(GetCategory());
		burned.Touchable = this.Touchable;
		burned->SetCon(GetCon());
		burned->SetR(GetR());
		burned->Incinerate(OnFire());
		burned->SetPosition(GetX(), GetY());
		Sound("TreeCrack", false);
		RemoveObject();
		return;
	}
}

private func MaxDamage()
{
	return 60;
}

local Name = "$Name$";
local Touchable = 0;
local BlastIncinerate = 2;
local ContactIncinerate = 6;
local NoBurnDecay = 1;